----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Gortok Palehoof"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 591 $"):sub(12, -3)))
if not mod then return end
mod.partyContent = true
mod.otherMenu = "Howling Fjord"
mod.zonename = BZ["Utgarde Pinnacle"]
mod.enabletrigger = boss 
mod.guid = 26687
mod.toggleOptions = {"roar", "impale", "bosskill"}

----------------------------------
--         Localization         --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "Gortok",
	impale = "Impale",
	impale_desc = "Warn who has Impale.",
	impale_message = "%s: %s",
	roar = "Withering Roar",
	roarcooldown_bar = "Roar cooldown",
	roar_desc = "Show the Withering Roar timer bar.",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Gortok",
	impale = "Durchbohren",
	impale_desc = "Warnen wer von Durchbohren getroffen ist.",
	impale_message = "%s: %s",
	roar = "Welkendes Gebrüll",
	roarcooldown_bar = "Gebrüll-Cooldown",
	roar_desc = "Die Timerleiste für Welkendes Gebrüll anzeigen.",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Gortok",
	impale = "Empaler",
	impale_desc = "Prévient quand un joueur subit les effets d'Empaler.",
	impale_message = "%s : %s",
	roar = "Rugissement d'affliction",
	roarcooldown_bar = "Recharge Rugissement",
	roar_desc = "Affiche une barre indiquant le temps de recharge du Rugissement d'affliction.",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "고르톡",
	impale = "꿰뚫기",
	impale_desc = "꿰뚫기에 걸린 플레이어를 알립니다.",
	impale_message = "%s: %s",
	roar = "부패의 포효",
	roarcooldown_bar = "포효 대기시간",
	roar_desc = "부패의 포효 타이머 바를 표시합니다.",
}

end )

L:RegisterTranslations("ruRU", function() return {
	cmd = "Gortok",
	impale = "Прокалывание",
	impale_desc = "Сообщать цель Прокалывания.",
	impale_message = "%s: %s",
	roar = "Губительный рев",
	roarcooldown_bar = "Перезарядка рева",
	roar_desc = "Отображать таймер губительного рева.",
}

end )

L:RegisterTranslations("zhCN", function() return {
	impale = "穿刺",
	impale_desc = "当玩家中了穿刺时发出警报。",
	impale_message = "%s：>%s<！",
	roar = "枯萎咆哮",
	roarcooldown_bar = "<枯萎咆哮 冷却>",
	roar_desc = "显示枯萎咆哮计时条。",
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "戈托克",
	impale = "刺穿",
	impale_desc = "當玩家中了刺穿時發出警報。",
	impale_message = "%s：>%s<！",
	roar = "枯萎咆哮",
	roarcooldown_bar = "<枯萎咆哮 冷卻>",
	roar_desc = "顯示枯萎咆哮計時條。",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Roar", 48256, 59267)
	self:AddCombatListener("SPELL_AURA_APPLIED", "Impale", 48261, 59268)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:Roar(_, spellId, _, _, spellName)
	if self.db.profile.roar then
		self:IfMessage(spellName, "Urgent", spellId)
		self:Bar(L["roarcooldown_bar"], 10, spellId)
	end
end

function mod:Impale(player, spellId, _, _, spellName)
	if self.db.profile.impale then
		self:IfMessage(L["impale_message"]:format(spellName, player), "Attention", spellId)
	end
end
